// third_party/blink/public/mojom/timing/performance_mark_or_measure.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_TIMING_PERFORMANCE_MARK_OR_MEASURE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_TIMING_PERFORMANCE_MARK_OR_MEASURE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/timing/performance_mark_or_measure.mojom-shared.h"
#include "third_party/blink/public/mojom/timing/performance_mark_or_measure.mojom-forward.h"
#include "mojo/public/mojom/base/big_buffer.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/public/common/common_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {








class BLINK_COMMON_EXPORT PerformanceMarkOrMeasure {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PerformanceMarkOrMeasure, T>::value>;
  using DataView = PerformanceMarkOrMeasureDataView;
  using Data_ = internal::PerformanceMarkOrMeasure_Data;
  using EntryType = PerformanceMarkOrMeasure_EntryType;

  template <typename... Args>
  static PerformanceMarkOrMeasurePtr New(Args&&... args) {
    return PerformanceMarkOrMeasurePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PerformanceMarkOrMeasurePtr From(const U& u) {
    return mojo::TypeConverter<PerformanceMarkOrMeasurePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PerformanceMarkOrMeasure>::Convert(*this);
  }


  PerformanceMarkOrMeasure();

  PerformanceMarkOrMeasure(
      const std::string& name,
      PerformanceMarkOrMeasure::EntryType entry_type,
      double start_time,
      double duration,
      base::Optional<::mojo_base::BigBuffer> detail);

  ~PerformanceMarkOrMeasure();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PerformanceMarkOrMeasurePtr>
  PerformanceMarkOrMeasurePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PerformanceMarkOrMeasure::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PerformanceMarkOrMeasure::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PerformanceMarkOrMeasure::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PerformanceMarkOrMeasure_UnserializedMessageContext<
            UserType, PerformanceMarkOrMeasure::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PerformanceMarkOrMeasure::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PerformanceMarkOrMeasure::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PerformanceMarkOrMeasure_UnserializedMessageContext<
            UserType, PerformanceMarkOrMeasure::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PerformanceMarkOrMeasure::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string name;
  
  PerformanceMarkOrMeasure::EntryType entry_type;
  
  double start_time;
  
  double duration;
  
  base::Optional<::mojo_base::BigBuffer> detail;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PerformanceMarkOrMeasure);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PerformanceMarkOrMeasure::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PerformanceMarkOrMeasure::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PerformanceMarkOrMeasure::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PerformanceMarkOrMeasure::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
PerformanceMarkOrMeasurePtr PerformanceMarkOrMeasure::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(entry_type),
      mojo::Clone(start_time),
      mojo::Clone(duration),
      mojo::Clone(detail)
  );
}

template <typename T, PerformanceMarkOrMeasure::EnableIfSame<T>*>
bool PerformanceMarkOrMeasure::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->entry_type, other_struct.entry_type))
    return false;
  if (!mojo::Equals(this->start_time, other_struct.start_time))
    return false;
  if (!mojo::Equals(this->duration, other_struct.duration))
    return false;
  if (!mojo::Equals(this->detail, other_struct.detail))
    return false;
  return true;
}

template <typename T, PerformanceMarkOrMeasure::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.name, rhs.name))
    return true;
  if (std::less<>{}(rhs.name, lhs.name))
    return false;
  if (std::less<>{}(lhs.entry_type, rhs.entry_type))
    return true;
  if (std::less<>{}(rhs.entry_type, lhs.entry_type))
    return false;
  if (std::less<>{}(lhs.start_time, rhs.start_time))
    return true;
  if (std::less<>{}(rhs.start_time, lhs.start_time))
    return false;
  if (std::less<>{}(lhs.duration, rhs.duration))
    return true;
  if (std::less<>{}(rhs.duration, lhs.duration))
    return false;
  if (std::less<>{}(lhs.detail, rhs.detail))
    return true;
  if (std::less<>{}(rhs.detail, lhs.detail))
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::PerformanceMarkOrMeasure::DataView,
                                         ::blink::mojom::PerformanceMarkOrMeasurePtr> {
  static bool IsNull(const ::blink::mojom::PerformanceMarkOrMeasurePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::PerformanceMarkOrMeasurePtr* output) { output->reset(); }

  static const decltype(::blink::mojom::PerformanceMarkOrMeasure::name)& name(
      const ::blink::mojom::PerformanceMarkOrMeasurePtr& input) {
    return input->name;
  }

  static decltype(::blink::mojom::PerformanceMarkOrMeasure::entry_type) entry_type(
      const ::blink::mojom::PerformanceMarkOrMeasurePtr& input) {
    return input->entry_type;
  }

  static decltype(::blink::mojom::PerformanceMarkOrMeasure::start_time) start_time(
      const ::blink::mojom::PerformanceMarkOrMeasurePtr& input) {
    return input->start_time;
  }

  static decltype(::blink::mojom::PerformanceMarkOrMeasure::duration) duration(
      const ::blink::mojom::PerformanceMarkOrMeasurePtr& input) {
    return input->duration;
  }

  static  decltype(::blink::mojom::PerformanceMarkOrMeasure::detail)& detail(
       ::blink::mojom::PerformanceMarkOrMeasurePtr& input) {
    return input->detail;
  }

  static bool Read(::blink::mojom::PerformanceMarkOrMeasure::DataView input, ::blink::mojom::PerformanceMarkOrMeasurePtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_TIMING_PERFORMANCE_MARK_OR_MEASURE_MOJOM_H_